'''
    Pokemon Now Add-on

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

from resources.lib import Addon, source
import sys, os, urllib, urllib2
import json
import xbmc, xbmcgui, xbmcplugin, xbmcaddon

import liveresolver
import urlresolver

addon = xbmcaddon.Addon()
addonname = addon.getAddonInfo('name')
addonid = addon.getAddonInfo('id')
plugin_path = xbmcaddon.Addon(id=addonid).getAddonInfo('path')

Addon.plugin_url = sys.argv[0]
Addon.plugin_handle = int(sys.argv[1])
Addon.plugin_queries = Addon.parse_query(sys.argv[2][1:])

dlg = xbmcgui.Dialog()

Addon.log('plugin url: ' + Addon.plugin_url)
Addon.log('plugin queries: ' + str(Addon.plugin_queries))
Addon.log('plugin handle: ' + str(Addon.plugin_handle)) 

addon_logo = xbmc.translatePath(os.path.join(plugin_path,'tvaddons_logo.png'))

mode = Addon.plugin_queries['mode']

if mode == 'main':
    Addon.add_directory({'mode': 'tv'}, 'TV Show')
    Addon.add_directory({'mode': 'tv_specials'}, 'TV Specials')
    Addon.add_directory({'mode': 'movies'}, 'Movies')
    if len(Addon.get_setting('notify')) > 0:
        Addon.set_setting('notify', str(int(Addon.get_setting('notify')) + 1))  
    else:
        Addon.set_setting('notify', "1")        
    if int(Addon.get_setting('notify')) == 1:
        xbmcgui.Dialog().notification(addonname + ' is provided by:','www.tvaddons.ag',addon_logo,5000,False)
    elif int(Addon.get_setting('notify')) == 9:
        Addon.set_setting('notify', "0")

if mode == 'tv':
    try:
        seasons = source.Source().build_tv()
        if seasons:
            for c in seasons:
                Addon.add_directory({'mode': c['title']}, c['title'], img=c['img'])
    except:
        dlg.ok(Addon.get_string(5000), Addon.get_string(8000))
        exit()

if mode == 'tv_specials':
    try:
        specials = source.Source().build_tv_specials()
    except:
        dlg.ok(Addon.get_string(5000), Addon.get_string(8000))
        exit()

if mode == 'movies':
    try:
        movies = source.Source().build_movies()
    except:
        dlg.ok(Addon.get_string(5000), Addon.get_string(8000))
        exit()

def show_streams_tv(title, seasonId):
    if mode == title:
        streams = source.Source().get_streams_tv(seasonId)
        if streams:
            for c in streams:
                title = c['title']
                channel = c['title']
                videoId = c['videoId']
                img = c['img']
                stream_type = c['stream_type']
                stream = c['stream']
                rURL = Addon.plugin_url + "?channel=" + channel + "&stream=" + stream + "&stream_type=" + stream_type + "&mode=play_tv&rand=" + Addon.random_generator()
                Addon.add_video_item(rURL, {'title': title}, img=img)

def show_streams_tv_specials(get_stream):
    if mode == 'play_special':
        stream = Addon.plugin_queries['stream']
        if stream == get_stream:
            stream_url = urlresolver.HostedMediaFile(stream).resolve()
            item = xbmcgui.ListItem(path=stream_url)
            xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)

def show_streams_movies(get_stream):
    if mode == 'play_movie':
        stream = Addon.plugin_queries['stream']
        if stream == get_stream:
            stream_url = urlresolver.HostedMediaFile(stream).resolve()
            item = xbmcgui.ListItem(path=stream_url)
            xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)

if mode != 'main' and mode != 'movies' and mode != 'tv_specials':
    seasons = source.Source().build_tv()
    if seasons:
        for c in seasons:
            show_streams_tv(c['title'], c['seasonId'])

if mode == 'play_tv':
    stream = Addon.plugin_queries['stream']
    stream_type = Addon.plugin_queries['stream_type']

    if stream_type == 'youtube':
        stream_url = urlresolver.HostedMediaFile(stream).resolve()
        item = xbmcgui.ListItem(path=stream_url)
        xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)
    else:
        stream_url = liveresolver.resolve(stream)
        item = xbmcgui.ListItem(path=stream_url)
        xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)

if mode != 'main' and mode != 'tv' and mode != 'movies' and 'Season' not in mode:
    specials = source.Source().build_tv_specials()
    if specials:
        for c in specials:
            title = c['title']
            channel = c['title']
            stream = c['stream']
            img = c['img']
            rURL = Addon.plugin_url + "?channel=" + channel + "&stream=" + stream + "&mode=play_special&rand=" + Addon.random_generator()
            Addon.add_video_item(rURL, {'title': title}, img=img)
            show_streams_tv_specials(stream)

if mode != 'main' and mode != 'tv' and mode != 'tv_specials' and 'Season' not in mode:
    movies = source.Source().build_movies()
    if movies:
        for c in movies:
            title = c['title']
            channel = c['title']
            stream = c['stream']
            img = c['img']
            rURL = Addon.plugin_url + "?channel=" + channel + "&stream=" + stream + "&mode=play_movie&rand=" + Addon.random_generator()
            Addon.add_video_item(rURL, {'title': title}, img=img)
            show_streams_movies(stream)

Addon.end_of_directory()
